## ros-iron-rclc-lifecycle 5.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(rclc_lifecycle)

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# maximum string length - should cover all lifecycle state and transition names
set(RCLC_LIFECYCLE_MAX_STRING_LENGTH 20 CACHE STRING "Set the maximum length for strings.")
add_definitions(-DRCLC_LIFECYCLE_MAX_STRING_LENGTH=${RCLC_LIFECYCLE_MAX_STRING_LENGTH})

# find dependencies
find_package(ament_cmake_ros REQUIRED)
find_package(std_msgs REQUIRED)
find_package(lifecycle_msgs REQUIRED)
find_package(rcl_lifecycle REQUIRED)
find_package(rclc REQUIRED)


if("${rcl_lifecycle_VERSION}" VERSION_LESS "1.0.0")
  message(STATUS "Found rcl_lifecycle version ${rcl_lifecycle_VERSION}, which belongs to Eloquent or earlier")
  if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wall -Wextra)
  endif()
else()
  message(STATUS "Found rcl_lifecycle version ${rcl_lifecycle_VERSION}, which belongs to Foxy or later")
  if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wall -Wextra -Wpedantic)
  endif()
endif()

# create library
add_library(${PROJECT_NAME}
  src/rclc_lifecycle/rclc_lifecycle.c
)
target_include_directories(${PROJECT_NAME}
    PUBLIC
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>
    PRIVATE
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
)
target_link_libraries(${PROJECT_NAME} ${CMAKE_THREAD_LIBS_INIT})
ament_target_dependencies(${PROJECT_NAME}
  rclc
  rcutils
  rcl_lifecycle
  std_msgs
  lifecycle_msgs
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME}
  PRIVATE "RCLC_LIFECYCLE_BUILDING_LIBRARY")


# install
#install(DIRECTORY include/ DESTINATION include)
#install(TARGETS ${PROJECT_NAME} DESTINATION lib)

install(
  TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

install(
  DIRECTORY include/
  DESTINATION include
)

ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})

if("${rcl_VERSION}" VERSION_LESS "1.1.10")
# ament_export_targets command is not available for Dashing
else()
ament_export_targets(${PROJECT_NAME})
endif()

if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  find_package(osrf_testing_tools_cpp REQUIRED)
  ament_lint_auto_find_test_dependencies()

  ament_add_gtest(${PROJECT_NAME}_test
    test/test_lifecycle.cpp)

  target_include_directories(${PROJECT_NAME}_test PRIVATE include src)
  target_link_libraries(${PROJECT_NAME}_test ${PROJECT_NAME})
  ament_target_dependencies(${PROJECT_NAME}_test
    rcl
    rcl_lifecycle
    rclc
    lifecycle_msgs
    osrf_testing_tools_cpp
  )
endif()

# export dependencies
# specific order: dependents before dependencies
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_export_dependencies(ament_cmake)
ament_export_dependencies(rcl)
ament_export_dependencies(rcl_lifecycle)
ament_export_dependencies(rcutils)
ament_export_dependencies(rosidl_generator_c)
ament_package()

=== debian/changelog ===
ros-iron-rclc-lifecycle (5.0.1-1jammy) jammy; urgency=high

  * no changes

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Wed, 14 Jun 2023 22:00:00 -0000

ros-iron-rclc-lifecycle (3.0.9-1jammy) jammy; urgency=high

  * Added documentation (#301)

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Tue, 21 Mar 2023 23:00:00 -0000

ros-iron-rclc-lifecycle (3.0.8-1jammy) jammy; urgency=high

  * Fix rclc lifecyle header (#279) (#281)

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Wed, 13 Apr 2022 22:00:00 -0000

ros-iron-rclc-lifecycle (3.0.7-1jammy) jammy; urgency=high

  * no changes

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Wed, 16 Feb 2022 23:00:00 -0000

ros-iron-rclc-lifecycle (3.0.6-1jammy) jammy; urgency=high

  * Create service context in main (#224)

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Mon, 24 Jan 2022 23:00:00 -0000

ros-iron-rclc-lifecycle (3.0.5-1jammy) jammy; urgency=high

  * no change

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Mon, 22 Nov 2021 23:00:00 -0000

ros-iron-rclc-lifecycle (3.0.4-1jammy) jammy; urgency=high

  * Provide lifecycle services in the rclc lifecycle nodes (#51)

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Tue, 16 Nov 2021 23:00:00 -0000

ros-iron-rclc-lifecycle (3.0.3-1jammy) jammy; urgency=high

  * Version bump

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Tue, 27 Jul 2021 22:00:00 -0000

ros-iron-rclc-lifecycle (3.0.2-1jammy) jammy; urgency=high

  * Version bump

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Sun, 25 Jul 2021 22:00:00 -0000

ros-iron-rclc-lifecycle (3.0.1-1jammy) jammy; urgency=high

  * Added quality declaration statement

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Fri, 16 Jul 2021 22:00:00 -0000

ros-iron-rclc-lifecycle (2.0.0-1jammy) jammy; urgency=high

  * added codecov support
  * new API of rcl_lifecycle in Rolling required major version bump

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Thu, 22 Apr 2021 22:00:00 -0000

ros-iron-rclc-lifecycle (1.0.1-1jammy) jammy; urgency=high

  * Windows port
  * Compatibility sleep function (Windows, POSIX-OS)
  * Fixed RCL lifecycle API change for Rolling

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Sun, 28 Mar 2021 22:00:00 -0000

ros-iron-rclc-lifecycle (1.0.0-1jammy) jammy; urgency=high

  * Updated version

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Wed, 03 Mar 2021 23:00:00 -0000

ros-iron-rclc-lifecycle (0.1.7-1jammy) jammy; urgency=high

  * Updated version

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Tue, 19 Jan 2021 23:00:00 -0000

ros-iron-rclc-lifecycle (0.1.6-1jammy) jammy; urgency=high

  * Updated version

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Tue, 19 Jan 2021 23:00:00 -0000

ros-iron-rclc-lifecycle (0.1.5-1jammy) jammy; urgency=high

  * Updated version

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Thu, 10 Dec 2020 23:00:00 -0000

ros-iron-rclc-lifecycle (0.1.4-1jammy) jammy; urgency=high

  * Fixed error in bloom release

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Tue, 24 Nov 2020 23:00:00 -0000

ros-iron-rclc-lifecycle (0.1.3-1jammy) jammy; urgency=high

  * Aligned version number to rclc repository

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Sun, 22 Nov 2020 23:00:00 -0000

ros-iron-rclc-lifecycle (0.1.0-1jammy) jammy; urgency=high

  * Initial release

 -- Jan Staschulat <jan.staschulat@de.bosch.com>  Sun, 22 Nov 2020 23:00:00 -0000

=== debian/control ===
Source: ros-iron-rclc-lifecycle
Section: misc
Priority: optional
Maintainer: Jan Staschulat <jan.staschulat@de.bosch.com>
Build-Depends: debhelper (>= 9.0.0), ros-iron-ament-cmake-gtest <!nocheck>, ros-iron-ament-cmake-ros, ros-iron-ament-lint-auto <!nocheck>, ros-iron-ament-lint-common <!nocheck>, ros-iron-lifecycle-msgs, ros-iron-osrf-testing-tools-cpp <!nocheck>, ros-iron-rcl-lifecycle, ros-iron-rclc, ros-iron-std-msgs, ros-iron-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-iron-rclc-lifecycle
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-iron-lifecycle-msgs, ros-iron-rcl-lifecycle, ros-iron-rclc, ros-iron-std-msgs, ros-iron-ros-workspace
Description: rclc lifecycle convenience methods.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-rclc-lifecycle//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
